> For the complete documentation index, see [llms.txt](https://docs.pinot.apache.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pinot.apache.org/functions/math/moduloorzero.md).

# moduloOrZero

Same as [MOD](/functions/math/mod.md) but returns zero when dividing by zero or when dividing `Long.MIN_VALUE` by `-1`. This is a polymorphic function that preserves the input numeric type.

## Signature

moduloOrZero(col1, col2)

| Argument | Type                                   | Description |
| -------- | -------------------------------------- | ----------- |
| `col1`   | INT, LONG, FLOAT, DOUBLE, BIG\_DECIMAL | Dividend    |
| `col2`   | INT, LONG, FLOAT, DOUBLE, BIG\_DECIMAL | Divisor     |

Returns the same numeric type as the inputs (or the wider type if inputs differ).

## Usage Examples

```sql
SELECT moduloOrZero(10, 3) AS value
FROM myTable
```

| value |
| ----- |
| 1     |

```sql
SELECT moduloOrZero(10, 0) AS value
FROM myTable
```

| value |
| ----- |
| 0     |

```sql
SELECT moduloOrZero(10L, 3L) AS long_modulo, moduloOrZero(10.5F, 3.0F) AS float_modulo, moduloOrZero(10.5, 3.0) AS double_modulo
FROM myTable
```

Returns LONG, FLOAT, DOUBLE respectively (preserving input type).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.pinot.apache.org/functions/math/moduloorzero.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
